       IDENTIFICATION DIVISION.
       PROGRAM-ID.    STAMLRC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: STAMLRC1.CBL
      * Copy Files:    CUSTCB01.CPY
      *                MAILCB01.CPY
      *                PASSROAD.CPY
      *                PASSPARS.CPY
      * Calls to:      SIMOROAD.CBL
      *                SIMOPARS.CBL
      *****************************************************************
      *
      *                     ************
      *                     * STAMLRJ1 *
      *                     ********jcl*
      *                          *
      *                     ************
      *                     * IEFBR14  *
      *                     ********utl*
      *                          *
      *    ************     ************     ************
      *    * CUSTMAST *-----* STAMLRC1 *-----* MAILTEMP *
      *    ********dat*     ********cbl*     ********dat*
      *                          *  *
      *                          *  *        ************
      *                          *  ***call*** SIMOROAD *
      *                          *           ********cbl*
      *                          *                *
      *                          *           ************
      *                          *           * SIMOPARS *
      *                          *           ********cbl*
      *                          *
      *    ************     ************     ************
      *    * MAILTEMP *-----*   SORT   *-----* MAILSORT *
      *    ********dat*     ********cbl*     ********dat*
      *                          *
      *                          *
      *    ************     ************     ************
      *    * MAILSORT *-----* STAMLRC2 *-----* MAILTEXT *
      *    ********dat*     ********cbl*     ********dat*
      *                          *
      *                          *
      *                     ************
      *                     *   EOJ    *
      *                     ************
      *
      *****************************************************************
      * This program will read the input file and create a sequential
      * output file with the records formatted to print mailing labels
      * four across a page of six lines each.
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT CUSTMAST-FILE  ASSIGN TO       CUSTMAST
                  ORGANIZATION IS INDEXED
                  ACCESS MODE  IS SEQUENTIAL
                  RECORD KEY   IS CUST-NUMBER
                  FILE STATUS  IS CUSTMAST-STATUS.
           SELECT MAILTEMP-FILE  ASSIGN TO       MAILTEMP
                  ORGANIZATION IS SEQUENTIAL
                  ACCESS MODE  IS SEQUENTIAL
                  FILE STATUS  IS MAILTEMP-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  CUSTMAST-FILE
           DATA RECORD    IS CUST-RECORD.
       COPY CUSTCB01.

       FD  MAILTEMP-FILE
           DATA RECORD    IS MAIL-RECORD.
       COPY MAILCB01.

      *****************************************************************
       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* STAMLRC1 '.
           05  T2 pic X(34) value 'Create Name-Address Labels File   '.
           05  T3 pic X(10) value ' v11.02.07'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* STAMLRC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* STAMLRC1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  CUSTMAST-STATUS.
           05  CUSTMAST-STATUS-L   pic X.
           05  CUSTMAST-STATUS-R   pic X.
       01  CUSTMAST-EOF            pic X       value 'N'.
       01  CUSTMAST-OPEN-FLAG      pic X       value 'C'.

       01  MAILTEMP-STATUS.
           05  MAILTEMP-STATUS-L   pic X.
           05  MAILTEMP-STATUS-R   pic X.
       01  MAILTEMP-EOF            pic X       value 'N'.
       01  MAILTEMP-OPEN-FLAG      pic X       value 'C'.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines   TWO-BYTES
                                   pic 9(4)    comp.
       01  IO-STATUS-4             pic 9(4)    value 0.
       01  IO-STATUS-4A            redefines   IO-STATUS-4
                                   pic X(4).

       01  PROGRAM-NAME            pic X(8)    value 'STAMLRC1'.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  OMIT-POB                pic X       value 'N'.
       01  ADDRESS-IS-POB          pic X       value 'N'.

       01  CUSTMAST-RDR            pic 9(9)    value 0.
       01  MAILTEMP-ADD            pic 9(9)    value 0.

       01  CUSTMAST-TOTAL.
           05  filler        pic X(23) value 'CUSTMAST line count is '.
           05  CUSTMAST-TOT  pic ZZZ,ZZZ,ZZ9.
       01  MAILTEMP-TOTAL.
           05  filler        pic X(23) value 'MAILTEMP line count is '.
           05  MAILTEMP-TOT  pic ZZZ,ZZZ,ZZ9.

      *****************************************************************
      * The following copy file of the pass area for calling SIMODATE,
      * the date editing routine.
      *****************************************************************
       COPY PASSROAD.
      *****************************************************************
       LINKAGE SECTION.
       01  PARM-BUFFER.
           05  PARM-LENGTH         pic S9(4)   comp.
           05  PARM-DATA           pic X(256).

      *****************************************************************
       PROCEDURE DIVISION using PARM-BUFFER.
           perform Z-POST-COPYRIGHT

           if  PARM-LENGTH > 0
               move PARM-DATA(1:PARM-LENGTH) to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               if  PARM-DATA(1:7) = 'NOPOBOX'
                   move 'Y' to OMIT-POB
               end-if
           end-if
      *
           perform CUSTMAST-OPEN
           perform MAILTEMP-OPEN

           perform until CUSTMAST-STATUS not = '00'
               perform CUSTMAST-READ
               if  CUSTMAST-STATUS = '00'
                   add 1 to CUSTMAST-RDR
                   if  OMIT-POB = 'Y'
                       perform TEST-FOR-POB
                   end-if
                   if  ADDRESS-IS-POB = 'N'
                       perform BUILD-OUTPUT-RECORD
                       perform MAILTEMP-WRITE
                       if  MAILTEMP-STATUS = '00'
                           add 1 to MAILTEMP-ADD
                       end-if
                   end-if
               end-if
           end-perform

           move CUSTMAST-RDR to CUSTMAST-TOT
           move CUSTMAST-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           move MAILTEMP-ADD to MAILTEMP-TOT
           move MAILTEMP-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           if  APPL-EOF
               move 'is Complete...' to MESSAGE-TEXT
               move ZERO to RETURN-CODE
           else
               move 'is ABENDING...' to MESSAGE-TEXT
               add 16 to ZERO giving RETURN-CODE
           end-if
           perform Z-DISPLAY-MESSAGE-TEXT

           perform MAILTEMP-CLOSE
           perform CUSTMAST-CLOSE
           GOBACK.

      *****************************************************************
      * The following routines are in alphabetical sequence..         *
      *****************************************************************
      *
      *****************************************************************
       BUILD-OUTPUT-RECORD.
           move SPACES to MAIL-RECORD
           move CUST-NUMBER      to MAIL-KEY
           move CUST-NAME        to MAIL-NAME.
           move CUST-ADDRESS-1   to MAIL-ADDRESS-1
           move CUST-ADDRESS-2   to MAIL-ADDRESS-2
           move CUST-CITY        to MAIL-CITY
           move CUST-STATE       to MAIL-STATE
           move CUST-POSTAL-CODE to MAIL-POSTAL-CODE
           exit.
      *
      *****************************************************************
      * I/O ROUTINES FOR CUSTMAST...                                  *
      *****************************************************************
       CUSTMAST-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close CUSTMAST-FILE
           if  CUSTMAST-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTMAST-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CUSTMAST-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTMAST-READ.
           read CUSTMAST-FILE
           if  CUSTMAST-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CUSTMAST-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to CUSTMAST-EOF
               else
                   move 'CUSTMAST-Failure-GET...' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move CUSTMAST-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTMAST-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input CUSTMAST-FILE
           if  CUSTMAST-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to CUSTMAST-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTMAST-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CUSTMAST-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O ROUTINES FOR MAILTEMP...                                  *
      *****************************************************************
       MAILTEMP-WRITE.
           if  MAILTEMP-OPEN-FLAG = 'C'
               perform MAILTEMP-OPEN
           end-if
           write MAIL-RECORD
           if  MAILTEMP-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  MAILTEMP-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'MAILTEMP-Failure-WRITE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move MAILTEMP-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       MAILTEMP-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT MAILTEMP-FILE
           if  MAILTEMP-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to MAILTEMP-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'MAILTEMP-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move MAILTEMP-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       MAILTEMP-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close MAILTEMP-FILE
           if  MAILTEMP-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to MAILTEMP-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'MAILTEMP-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move MAILTEMP-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
       TEST-FOR-POB.
           move 'N' to ADDRESS-IS-POB
           move 'SIMOROAD'      to RDPA-REQUEST
           move 'INP '          to RDPA-ADR1-CNTL
           move CUST-ADDRESS-1  to RDPA-ADR1-DATA
           add length of CUST-ADDRESS-1 to ZERO giving RDPA-ADR1-SIZE
           call 'SIMOROAD' using ROAD-PASS-AREA

           if  RDPA-RESULT = 0
           and RDPA-ADR2-CNTL = 'POB '
               move 'Y' to ADDRESS-IS-POB
           end-if

           exit.
      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           GOBACK.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79) upon console
           else
               display MESSAGE-BUFFER upon console
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-4
               move IO-STAT1 to IO-STATUS-4A(1:1)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-4A to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-4A
               move IO-STATUS to IO-STATUS-4A(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-4A to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE upon console
           display SIM-COPYRIGHT upon console
           exit.

      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
