       IDENTIFICATION DIVISION.
       PROGRAM-ID.    STAMLRC2.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: STAMLRC2.CBL
      * Copy Files:    MAILCB01.CPY
      *****************************************************************
      *
      *                     ************
      *                     * STAMLRJ1 *
      *                     ********jcl*
      *                          *
      *                     ************
      *                     * IEFBR14  *
      *                     ********utl*
      *                          *
      *    ************     ************     ************
      *    * CUSTMAST *-----* STAMLRC1 *-----* MAILTEMP *
      *    ********dat*     ********cbl*     ********dat*
      *                          *  *
      *                          *  *        ************
      *                          *  *--call--* SIMOROAD *
      *                          *           ********cbl*
      *                          *                *
      *                          *           ************
      *                          *           * SIMOPARS *
      *                          *           ********cbl*
      *                          *
      *    ************     ************     ************
      *    * MAILTEMP *-----*   SORT   *-----* MAILSORT *
      *    ********dat*     ********cbl*     ********dat*
      *                          *
      *                          *
      *    ************     ************     ************
      *    * MAILSORT *-----* STAMLRC2 *-----* MAILTEXT *
      *    ********dat*     ********cbl*     ********dat*
      *                          *
      *                          *
      *                     ************
      *                     *   EOJ    *
      *                     ************
      *
      *****************************************************************
      * This program will read the input file and create a sequential
      * output file with the records formatted to print mailing labels
      * four across a page of six lines each.
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT MAILSORT-FILE ASSIGN to MAILSORT
                  ORGANIZATION is SEQUENTIAL
                  ACCESS MODE  is SEQUENTIAL
                  FILE STATUS  is MAILSORT-STATUS.
           SELECT MAILTEXT-FILE ASSIGN to MAILTEXT
                  ORGANIZATION is SEQUENTIAL
                  ACCESS MODE  is SEQUENTIAL
                  FILE STATUS  is MAILTEXT-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD   MAILSORT-FILE
            DATA RECORD    IS MAIL-RECORD.
       COPY MAILCB01.

       FD  MAILTEXT-FILE
           DATA RECORD    is MAILTEXT-RECORD.
       01 MAILTEXT-RECORD.
           05 MAILTEXT-DATA         pic X(192).

       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* STAMLRC2 '.
           05  T2 pic X(34) value 'Print Mail Labels, 1-4 Across     '.
           05  T3 pic X(10) value ' v09.11.25'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* STAMLRC2 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* STAMLRC2 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* STAMLRC2 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* STAMLRC2 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  MAILSORT-STATUS.
           05 MAILSORT-STATUS-L    pic X.
           05 MAILSORT-STATUS-R    pic X.
       01  MAILSORT-EOF            pic X       value 'N'.
       01  MAILSORT-OPEN-FLAG      pic X       value 'C'.

       01  MAILTEXT-STATUS.
           05 MAILTEXT-STATUS-L    pic X.
           05 MAILTEXT-STATUS-R    pic X.
       01  MAILTEXT-EOF            pic X       value 'N'.
       01  MAILTEXT-OPEN-FLAG      pic X       value 'C'.

       01  WORK-30-GROUP.
           05  filler              pic X       value SPACE.
           05  WORK-30             pic X(30)   value SPACES.
       01  WORK-30-LS              redefines   WORK-30-GROUP
                                   pic X(31).

       01  WORK-80                 pic X(80)   value SPACES.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.

       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines   TWO-BYTES pic 9(4) comp.
       01  THREE-BYTE-VALUE        pic 9(3)    value 0.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  P-LABELS.
           05  P-LABELS-ARRAY                  occurs 6 TIMES.
               10  P-LABELS-CELL   pic X(48)   occurs 4 TIMES
                                               value SPACES.

       01  P-IX1                   pic 9(2)    value 0.
       01  P-IX2                   pic 9(2)    value 0.
       01  P-IX3                   pic 9(2)    value 0.

       01  ACROSS-NUMBER-TEXT.
           05  filler    pic X(27) value 'Number of labels across is '.
           05  ACROSS-NUMBER-X.
               10  ACROSS-NUMBER   pic 9       value 4.

       01  MAILSORT-RDR            pic 9(9)    value 0.
       01  MAILTEXT-ADD            pic 9(9)    value 0.

       01  MAILSORT-TOTAL.
           05  filler        pic X(23) value 'MAILSORT line count is '.
           05  MAILSORT-TOT  pic ZZZ,ZZZ,ZZ9.
       01  MAILTEXT-TOTAL.
           05  filler        pic X(23) value 'MAILTEXT line count is '.
           05  MAILTEXT-TOT  pic ZZZ,ZZZ,ZZ9.

      *****************************************************************
       LINKAGE SECTION.
       01  PARM-BUFFER.
           05  PARM-LENGTH         pic S9(4)   comp.
           05  PARM-DATA           pic X(256).

      *****************************************************************
       PROCEDURE DIVISION using PARM-BUFFER.

           perform Z-POST-COPYRIGHT

           if  PARM-LENGTH = 1
           and PARM-DATA(1:1) is NUMERIC
               move PARM-DATA(1:1) to ACROSS-NUMBER-X
           end-if
           move ACROSS-NUMBER-TEXT to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           perform MAILSORT-OPEN
           perform MAILTEXT-OPEN

           perform until MAILSORT-STATUS not = '00'
               perform MAILSORT-READ
               if  MAILSORT-STATUS = '00'
                   add 1 to MAILSORT-RDR
                   add 1 to P-IX1
                   add 2 to ZERO giving P-IX2

                   move SPACES to WORK-80
                   move MAIL-FIRST-NAME to WORK-80
                   move MAIL-MID-NAME to WORK-30
                   inspect WORK-80 replacing
                    first '                               '
                       by  WORK-30-LS
                   move MAIL-LAST-NAME  to WORK-30
                   inspect WORK-80 replacing
                    first '                               '
                       by  WORK-30-LS

                   move WORK-80 to P-LABELS-CELL(P-IX2, P-IX1)

                   add 1 to P-IX2

                   if  MAIL-ADDRESS-1 not = SPACES
                       move MAIL-ADDRESS-1
                         to P-LABELS-CELL(P-IX2, P-IX1)
                       add 1 to P-IX2
                   end-if

                   if  MAIL-ADDRESS-2 not = SPACES
                       move MAIL-ADDRESS-2
                         to P-LABELS-CELL(P-IX2, P-IX1)
                       add 1 to P-IX2
                   end-if

                   string MAIL-CITY  delimited by '  '
                          ', '       delimited by SIZE
                          MAIL-STATE delimited by '  '
                          ' '        delimited by SIZE
                          MAIL-POSTAL-CODE delimited by '  '
                          into P-LABELS-CELL(P-IX2, P-IX1)
                   end-string
               end-if
               if  P-IX1 = ACROSS-NUMBER
                   add P-IX1 to MAILTEXT-ADD
                   perform PRINT-LABEL-SET-AND-CLEAR
                   subtract P-IX1 from P-IX1
               end-if
           end-perform

           if  P-IX1 > 0
               add P-IX1 to MAILTEXT-ADD
               perform PRINT-LABEL-SET-AND-CLEAR
               subtract P-IX1 from P-IX1
           end-if

           move MAILSORT-RDR to MAILSORT-TOT
           move MAILSORT-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           move MAILTEXT-ADD to MAILTEXT-TOT
           move MAILTEXT-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           perform Z-THANK-YOU

           GOBACK.

      *****************************************************************
       PRINT-LABEL-SET-AND-CLEAR.
           add 1 to ZERO giving P-IX3
           perform 6 TIMES
               move P-LABELS-ARRAY(P-IX3) to MAILTEXT-DATA
               perform MAILTEXT-WRITE
               move SPACES to P-LABELS-ARRAY(P-IX3)
               add 1 to P-IX3
           end-perform
           exit.

      *****************************************************************
      * I/O ROUTINES FOR MAILSORT...                                  *
      *****************************************************************
       MAILSORT-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close MAILSORT-FILE
           if MAILSORT-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'MAILSORT-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move MAILSORT-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       MAILSORT-READ.
           read MAILSORT-FILE
           if MAILSORT-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if MAILSORT-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to MAILSORT-EOF
               else
                   move 'MAILSORT-Failure-GET...' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move MAILSORT-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       MAILSORT-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input MAILSORT-FILE
           if MAILSORT-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to MAILSORT-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'MAILSORT-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move MAILSORT-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O ROUTINES FO RMAILTEXT...                                  *
      *****************************************************************
       MAILTEXT-WRITE.
           if MAILTEXT-OPEN-FLAG = 'C'
               perform MAILTEXT-OPEN
           end-if
           write MAILTEXT-RECORD
           if MAILTEXT-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if MAILTEXT-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'MAILTEXT-Failure-WRITE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move MAILTEXT-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       MAILTEXT-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open output MAILTEXT-FILE
           if MAILTEXT-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to MAILTEXT-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'MAILTEXT-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move MAILTEXT-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       MAILTEXT-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close MAILTEXT-FILE
           if MAILTEXT-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to MAILTEXT-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'MAILTEXT-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move MAILTEXT-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           GOBACK.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79) upon console
           else
               display MESSAGE-BUFFER upon console
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving THREE-BYTE-VALUE
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STAT1 to MESSAGE-TEXT(17:1)
               move THREE-BYTE-VALUE to MESSAGE-TEXT(18:3)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move 'File Status is: 00nn' to MESSAGE-TEXT
               move IO-STATUS to MESSAGE-TEXT(19:2)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE upon console
           display SIM-COPYRIGHT upon console
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01 upon console
           display SIM-THANKS-02 upon console
           exit.

      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
